/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface.CreditApprovalExceptionHelper
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/CreditApprovalExceptionHelper.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/CreditApprovalException:1.0
</ul>
<b>IDL definition:</b>
<pre>
    exception CreditApprovalException {
      string reason;
    };
</pre>
</p>
*/
abstract public class CreditApprovalExceptionHelper {
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApprovalException read(org.omg.CORBA.portable.InputStream _input) {
    if(!_input.read_string().equals(id())) {
      throw new org.omg.CORBA.MARSHAL("Mismached repository id");
    }
    borland.reference.creditapproval.CORBAInterface.CreditApprovalException result = new borland.reference.creditapproval.CORBAInterface.CreditApprovalException();
    result.reason = _input.read_string();
    return result;
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, borland.reference.creditapproval.CORBAInterface.CreditApprovalException value) {
    _output.write_string(id());
    _output.write_string(value.reason);
  }
  public static void insert(org.omg.CORBA.Any any, borland.reference.creditapproval.CORBAInterface.CreditApprovalException value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApprovalException extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[1];
      members[0] = new org.omg.CORBA.StructMember("reason", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
      _type = _orb().create_exception_tc(id(), "CreditApprovalException", members);
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:borland/reference/creditapproval/CORBAInterface/CreditApprovalException:1.0";
  }
}
