/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package visibroker.samples.interceptor.timer;

public class TwoTimerData
{
    private TimerData   _t1;
    private TimerData   _t2;
    private String      _operation;

    public TwoTimerData(TimerData start1, TimerData start2, String operation)
    {
        _t1 = start1;
        _t2 = start2;
        _operation = operation;
    }

    public TwoTimerData(TimerData start1, String operation)
    {
        this(start1, null, operation);
    }

    public TimerData    getStart1()
    {
        return _t1;
    }

    public TimerData    getStart2()
    {
        return _t2;
    }

    public String       getOperation()
    {
        return _operation;
    }

    public void setStart1(TimerData start1)
    {
        _t1 = start1;
    }

    public void setStart2(TimerData start2)
    {
        _t2 = start2;
    }

    public void setOperation(String operation)
    {
        _operation = operation;
    }
}
