/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface._st_ClientCallback
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/_st_ClientCallback.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::ClientCallback
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/ClientCallback:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ClientCallback {
      void updateStatusText(
        in string newStatus
      );
    };
</pre>
</p>
*/
public class _st_ClientCallback extends org.omg.CORBA.portable.ObjectImpl implements borland.reference.creditapproval.CORBAInterface.ClientCallback {
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:borland/reference/creditapproval/CORBAInterface/ClientCallback:1.0"
  };
  /**
  <p>
  Operation: <b>::borland::reference::creditapproval::CORBAInterface::ClientCallback::updateStatusText</b>.
  <pre>
    void updateStatusText(
      in string newStatus
    );
  </pre>
  </p>
  */
  public void updateStatusText(
    java.lang.String newStatus
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("updateStatusText", true);
      _output.write_string(newStatus);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      updateStatusText(
        newStatus
      );
    }
  }
}
