/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface._st_CreditApprovalDispenser
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/_st_CreditApprovalDispenser.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::CreditApprovalDispenser
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/CreditApprovalDispenser:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface CreditApprovalDispenser {
      ::borland::reference::creditapproval::CORBAInterface::CreditApproval reserveCreditApprovalObject(
      )
      raises(
        ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException
      );
      void releaseCreditApprovalObject(
        in ::borland::reference::creditapproval::CORBAInterface::CreditApproval creditApprovalObject
      )
      raises(
        ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException
      );
    };
</pre>
</p>
*/
public class _st_CreditApprovalDispenser extends org.omg.CORBA.portable.ObjectImpl implements borland.reference.creditapproval.CORBAInterface.CreditApprovalDispenser {
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:borland/reference/creditapproval/CORBAInterface/CreditApprovalDispenser:1.0"
  };
  /**
  <p>
  Operation: <b>::borland::reference::creditapproval::CORBAInterface::CreditApprovalDispenser::reserveCreditApprovalObject</b>.
  <pre>
    ::borland::reference::creditapproval::CORBAInterface::CreditApproval reserveCreditApprovalObject(
    )
    raises(
      ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException
    );
  </pre>
  </p>
  */
  public borland.reference.creditapproval.CORBAInterface.CreditApproval reserveCreditApprovalObject(
  ) throws
    borland.reference.creditapproval.CORBAInterface.CreditApprovalException {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("reserveCreditApprovalObject", true);
      org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
      if(_exception_id.value != null) {
        if(_exception_id.value.equals(borland.reference.creditapproval.CORBAInterface.CreditApprovalExceptionHelper.id())) {
          throw borland.reference.creditapproval.CORBAInterface.CreditApprovalExceptionHelper.read(_input);
        }
        throw new org.omg.CORBA.MARSHAL
          ("Unexpected User Exception: " + _exception_id.value);
      }
      borland.reference.creditapproval.CORBAInterface.CreditApproval _result;
      _result = borland.reference.creditapproval.CORBAInterface.CreditApprovalHelper.read(_input);
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return reserveCreditApprovalObject();
    }
  }
  /**
  <p>
  Operation: <b>::borland::reference::creditapproval::CORBAInterface::CreditApprovalDispenser::releaseCreditApprovalObject</b>.
  <pre>
    void releaseCreditApprovalObject(
      in ::borland::reference::creditapproval::CORBAInterface::CreditApproval creditApprovalObject
    )
    raises(
      ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException
    );
  </pre>
  </p>
  */
  public void releaseCreditApprovalObject(
    borland.reference.creditapproval.CORBAInterface.CreditApproval creditApprovalObject
  ) throws
    borland.reference.creditapproval.CORBAInterface.CreditApprovalException {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("releaseCreditApprovalObject", true);
      borland.reference.creditapproval.CORBAInterface.CreditApprovalHelper.write(_output, creditApprovalObject);
      org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
      if(_exception_id.value != null) {
        if(_exception_id.value.equals(borland.reference.creditapproval.CORBAInterface.CreditApprovalExceptionHelper.id())) {
          throw borland.reference.creditapproval.CORBAInterface.CreditApprovalExceptionHelper.read(_input);
        }
        throw new org.omg.CORBA.MARSHAL
          ("Unexpected User Exception: " + _exception_id.value);
      }
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      releaseCreditApprovalObject(
        creditApprovalObject
      );
    }
  }
}
