/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface.applicantInfoStruct
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/applicantInfoStruct.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::applicantInfoStruct
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/applicantInfoStruct:1.0
</ul>
<b>IDL definition:</b>
<pre>
    struct applicantInfoStruct {
      string firstName;
      string MI;
      string lastName;
      string address1;
      string address2;
      string city;
      string state;
      string postalCode;
      string country;
      string phone;
      string PID;
      string DOB;
      double monthlyIncome;
      double rentMortgagePayment;
    };
</pre>
</p>
*/
final public class applicantInfoStruct {
  public java.lang.String firstName;
  public java.lang.String MI;
  public java.lang.String lastName;
  public java.lang.String address1;
  public java.lang.String address2;
  public java.lang.String city;
  public java.lang.String state;
  public java.lang.String postalCode;
  public java.lang.String country;
  public java.lang.String phone;
  public java.lang.String PID;
  public java.lang.String DOB;
  public double monthlyIncome;
  public double rentMortgagePayment;
  public applicantInfoStruct() {
  }
  public applicantInfoStruct(
    java.lang.String firstName,
    java.lang.String MI,
    java.lang.String lastName,
    java.lang.String address1,
    java.lang.String address2,
    java.lang.String city,
    java.lang.String state,
    java.lang.String postalCode,
    java.lang.String country,
    java.lang.String phone,
    java.lang.String PID,
    java.lang.String DOB,
    double monthlyIncome,
    double rentMortgagePayment
  ) {
    this.firstName = firstName;
    this.MI = MI;
    this.lastName = lastName;
    this.address1 = address1;
    this.address2 = address2;
    this.city = city;
    this.state = state;
    this.postalCode = postalCode;
    this.country = country;
    this.phone = phone;
    this.PID = PID;
    this.DOB = DOB;
    this.monthlyIncome = monthlyIncome;
    this.rentMortgagePayment = rentMortgagePayment;
  }
  public java.lang.String toString() {
    org.omg.CORBA.Any any = org.omg.CORBA.ORB.init().create_any();
    borland.reference.creditapproval.CORBAInterface.applicantInfoStructHelper.insert(any, this);
    return any.toString();
  }
}
