/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface.creditApprovalStruct
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/creditApprovalStruct.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::creditApprovalStruct
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/creditApprovalStruct:1.0
</ul>
<b>IDL definition:</b>
<pre>
    struct creditApprovalStruct {
      boolean approved;
      string creditCardNumber;
      string expirationDate;
      double limit;
    };
</pre>
</p>
*/
final public class creditApprovalStruct {
  public boolean approved;
  public java.lang.String creditCardNumber;
  public java.lang.String expirationDate;
  public double limit;
  public creditApprovalStruct() {
  }
  public creditApprovalStruct(
    boolean approved,
    java.lang.String creditCardNumber,
    java.lang.String expirationDate,
    double limit
  ) {
    this.approved = approved;
    this.creditCardNumber = creditCardNumber;
    this.expirationDate = expirationDate;
    this.limit = limit;
  }
  public java.lang.String toString() {
    org.omg.CORBA.Any any = org.omg.CORBA.ORB.init().create_any();
    borland.reference.creditapproval.CORBAInterface.creditApprovalStructHelper.insert(any, this);
    return any.toString();
  }
}
