/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface.creditApprovalStructHelper
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/creditApprovalStructHelper.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::creditApprovalStruct
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/creditApprovalStruct:1.0
</ul>
<b>IDL definition:</b>
<pre>
    struct creditApprovalStruct {
      boolean approved;
      string creditCardNumber;
      string expirationDate;
      double limit;
    };
</pre>
</p>
*/
abstract public class creditApprovalStructHelper {
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static borland.reference.creditapproval.CORBAInterface.creditApprovalStruct read(org.omg.CORBA.portable.InputStream _input) {
    borland.reference.creditapproval.CORBAInterface.creditApprovalStruct result = new borland.reference.creditapproval.CORBAInterface.creditApprovalStruct();
    result.approved = _input.read_boolean();
    result.creditCardNumber = _input.read_string();
    result.expirationDate = _input.read_string();
    result.limit = _input.read_double();
    return result;
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, borland.reference.creditapproval.CORBAInterface.creditApprovalStruct value) {
    _output.write_boolean(value.approved);
    _output.write_string(value.creditCardNumber);
    _output.write_string(value.expirationDate);
    _output.write_double(value.limit);
  }
  public static void insert(org.omg.CORBA.Any any, borland.reference.creditapproval.CORBAInterface.creditApprovalStruct value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static borland.reference.creditapproval.CORBAInterface.creditApprovalStruct extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[4];
      members[0] = new org.omg.CORBA.StructMember("approved", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean), null);
      members[1] = new org.omg.CORBA.StructMember("creditCardNumber", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
      members[2] = new org.omg.CORBA.StructMember("expirationDate", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
      members[3] = new org.omg.CORBA.StructMember("limit", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_double), null);
      _type = _orb().create_struct_tc(id(), "creditApprovalStruct", members);
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:borland/reference/creditapproval/CORBAInterface/creditApprovalStruct:1.0";
  }
}
