/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.reference.creditapproval.CORBAInterface;
/**
<p>
<ul>
<li> <b>Java Class</b> borland.reference.creditapproval.CORBAInterface.CreditApprovalHelper
<li> <b>Source File</b> borland/reference/creditapproval/CORBAInterface/CreditApprovalHelper.java
<li> <b>IDL Source File</b> C:/JBuilder/samples/borland/reference/creditapproval/CreditApproval.idl
<li> <b>IDL Absolute Name</b> ::borland::reference::creditapproval::CORBAInterface::CreditApproval
<li> <b>Repository Identifier</b> IDL:borland/reference/creditapproval/CORBAInterface/CreditApproval:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface CreditApproval {
      ::borland::reference::creditapproval::CORBAInterface::creditApprovalStruct getCreditApproval(
        in ::borland::reference::creditapproval::CORBAInterface::applicantInfoStruct appInfo,
        in ::borland::reference::creditapproval::CORBAInterface::ClientCallback callback
      )
      raises(
        ::borland::reference::creditapproval::CORBAInterface::CreditApprovalException,
        ::borland::reference::creditapproval::CORBAInterface::CreditDeniedException
      );
    };
</pre>
</p>
*/
abstract public class CreditApprovalHelper {
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static borland.reference.creditapproval.CORBAInterface.CreditApproval narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof borland.reference.creditapproval.CORBAInterface.CreditApproval) {
      return (borland.reference.creditapproval.CORBAInterface.CreditApproval) object;
    }
    if(is_a || object._is_a(id())) {
      borland.reference.creditapproval.CORBAInterface.CreditApproval result = new borland.reference.creditapproval.CORBAInterface._st_CreditApproval();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return result;
    }
    return null;
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval read(org.omg.CORBA.portable.InputStream _input) {
    return borland.reference.creditapproval.CORBAInterface.CreditApprovalHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, borland.reference.creditapproval.CORBAInterface.CreditApproval value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, borland.reference.creditapproval.CORBAInterface.CreditApproval value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static borland.reference.creditapproval.CORBAInterface.CreditApproval extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "CreditApproval");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:borland/reference/creditapproval/CORBAInterface/CreditApproval:1.0";
  }
}
