/*******************************************************************************/
/* This file contains the DML for stocking the various tables with test data. */
/*******************************************************************************/

/* Connect to cliffhanger.gdb in the current directory */

CONNECT "cliffhanger.gdb"
   USER "SYSDBA"
   PASSWORD "masterkey";



/*******************************************************************************/
/* CATEGORY TABLE */
/*******************************************************************************/
INSERT INTO L_ProductCategory
   VALUES ("Active Wear");

INSERT INTO L_ProductCategory
   VALUES ("Backpacks");

INSERT INTO L_ProductCategory
   VALUES ("Camping");

INSERT INTO L_ProductCategory
   VALUES ("Canteens");

INSERT INTO L_ProductCategory
   VALUES ("Climbing");

INSERT INTO L_ProductCategory
   VALUES ("Fishing");

INSERT INTO L_ProductCategory
   VALUES ("Food");

INSERT INTO L_ProductCategory
   VALUES ("Hiking");

INSERT INTO L_ProductCategory
   VALUES ("Mountain Biking");

INSERT INTO L_ProductCategory
   VALUES ("Skiing");

INSERT INTO L_ProductCategory
   VALUES ("Stoves");

INSERT INTO L_ProductCategory
   VALUES ("Tents");

INSERT INTO L_ProductCategory
   VALUES ("Water Sports");



/*******************************************************************************/
/* PRODUCT TABLE */
/*******************************************************************************/
INSERT INTO Product
   VALUES (NULL, 1, "Cliffhanger Alpine Tent", "Tents", 249.99, 0.0, 200, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Cliffhanger Tundra Tent", "Tents", 129.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Cliffhanger LifeStar Tent", "Tents", 109.99, 10.0, 50, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Stovemaster Camper Stove", "Stoves", 22.99, 0.0, 100, 50 );

INSERT INTO Product
   VALUES (NULL, 1, "Cascade Cookset", "Camping", 32.99, 0.0, 70, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "AirTech Comfort Mat", "Camping", 49.99, 10.0, 80, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "First-Aid Kit", "Camping", 6.99, 0.0, 50, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Glo Area Lantern", "Camping", 11.49, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Trailmaster Summit Pack", "Backpacks", 269.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Trailmaster Sierra Pack", "Backpacks", 179.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Olympic Trail Parka", "Active Wear", 119.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Outdoor X-Training Jacket", "Active Wear", 49.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Outdoor X-Training Pants", "Active Wear", 44.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Microfleece Pullover", "Active Wear", 46.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Junior Alpen Vest", "Active Wear", 31.99, 10.0, 50, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "Teca Sandals", "Active Wear", 64.99, 0.0, 50, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "AirTec Hiking Boots", "Hiking", 135.0, 10.0, 40, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Titanium Sunglasses", "Active Wear", 125.0, 0.0, 20, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "Diamond Back Mongoose", "Mountain Biking", 579.99, 10.0, 30, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Schwinn Racer", "Mountain Biking", 879.99, 30.0, 20, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Super Bike Junior", "Mountain Biking", 259.99, 10.0, 45, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Performance Ace", "Mountain Biking", 699.90, 0.0, 150, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Biking Shorts", "Mountain Biking", 34.99, 0.0, 20, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Air Blast Helmet", "Mountain Biking", 39.99, 0.0, 40, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Kamikaze Mini Pump", "Mountain Biking", 14.90, 0.0, 30, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Vilite Safety Light", "Mountain Biking", 15.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Rossignol X-Pro Skis", "Skiing", 250.0, 15.0, 30, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "Rossignol Junior Skis", "Skiing", 150.0, 10.0, 50, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "11mm x 50m Dry Rope", "Climbing", 109.99, 0.0, 120, 50 );

INSERT INTO Product
   VALUES (NULL, 1, "Diamond Bent Carabiners", "Climbing", 7.39, 5.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Diamond Straight Carabiners", "Climbing", 5.79, 5.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Ascension Ascender", "Climbing", 37.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Antishock Trekking Poles", "Climbing", 86.99, 0.0, 100, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Metal Canteen, 16 oz.", "Canteens", 16.99, 7.0, 50, 30 );

INSERT INTO Product
   VALUES (NULL, 1, "SuperSoak Plastic Canteen, 64 oz.", "Canteens", 8.99, 0.0, 100, 25 );

INSERT INTO Product
   VALUES (NULL, 1, "Mr. Fish Expert Reel", "Fishing", 129.99, 0.0, 10, 5 );

INSERT INTO Product
   VALUES (NULL, 1, "Rubber worms, 30 pack", "Fishing", 6.99, 10.0, 50, 10 );

INSERT INTO Product
   VALUES (NULL, 1, "Cliffhanger Tent Stakes, 8 pack", "Tents", 12.99, 0.0, 100, 20 );

INSERT INTO Product
   VALUES (NULL, 1, "Cliffhanger Trail Munchies", "Food", 6.99, 0.0, 50, 5 );

INSERT INTO Product
   VALUES (NULL, 1, "Dehydrated Milk", "Food", 10.50, 0.0, 50, 10 );



/*******************************************************************************/
/* CUSTOMER TABLE */
/*******************************************************************************/
INSERT INTO Customer
   VALUES (NULL, "Mary", "J", "Jenkins", "(206)523-9090", "(206)523-9000", "mjenkins@aol.com", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA", "Mary J. Jenkins",
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA" );

INSERT INTO Customer
   VALUES (NULL, "Jeffery", "M", "Robins", "(808)521-1234", "(808)521-1000", "jrobins@dnet.com", 
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA", "Jeffery M. Robins",
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA" );

INSERT INTO Customer
   VALUES (NULL, "Richard", "W", "Smith", "(206)632-1619", "(206)632-1122", "richs@lazernet.com", 
           "4500 45th Ave SW #401", "", "Seattle", "WA", "98188", "USA", "Richard W. Smith",
           "4500 45th Ave SW #401", "", "Seattle", "WA", "98188", "USA" );

INSERT INTO Customer
   VALUES (NULL, "Gregor", "F", "Neumann", "(177)322-7261", "(177)322-2345", "gneumann@studbox.uni-stuttgart.de", 
           "Gotenweg 13", "", "Uhingen", "", "73066", "Germany", "Gregor F. Neumann",
           "Gotenweg 13", "", "Uhingen", "", "73066", "Germany" );

INSERT INTO Customer
   VALUES (NULL, "Anelia", "D", "Atanassovich", "45-37-95", "", "", 
           "24 Vladivostok Str.", "", "Plovdiv", "", "4002", "Bulgaria", "Anelia D. Atanassovich",
           "24 Vladivostok Str.", "", "Plovdiv", "", "4002", "Bulgaria" );

INSERT INTO Customer
   VALUES (NULL, "John", "J", "Kuslich", "206-244-2400", "", "jjk@appmethods.com",
           "6300 Southcenter Blvd.", "Suite 200", "Seattle", "WA", "98188", "US", "John J. Kuslich",
           "6300 Southcenter Blvd.", "Suite 200", "Seattle", "WA", "98188", "US" );

INSERT INTO Customer
   VALUES (NULL, "Marcellino", "F", "Tanumihardja", "206-244-2400", "", "marcelt@appmethods.com",
           "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US", "Marcellino F. Tanumihardja",
           "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US" );

INSERT INTO Customer
   VALUES (NULL, "Bert", "C", "Owbean", "813-555-1234", "", "bowbean@borland.com",
           "81406 E. Greenpark Dr.", "", "Clearwater", "FL", "04148", "US", "Bert C. Owbean",
           "81406 E. Greenpark Dr.", "", "Clearwater", "FL", "04148", "US" );

INSERT INTO Customer
   VALUES (NULL, "Dennis", "B", "Freeson", "808-555-1234", "", "dennis@q3.net",
           "123 Main St.", "", "Hilo", "HI", "98619", "US", "Dennis B. Freeson",
           "123 Main St.", "", "Hilo", "HI", "98619", "US" );

INSERT INTO Customer
   VALUES (NULL, "Gary", "E", "Lee", "516-555-9888", "", "geddy@rush.net",
           "345 Maple Rd.", "", "Middletown", "PA", "67098", "US", "Gary E. Lee",
           "345 Maple Rd.", "", "Middletown", "PA", "67098", "US" );

INSERT INTO Customer
   VALUES (NULL, "Neil", "P", "Lifeson", "312-555-4433", "", "neilp@rush.net",
           "598 W. 3rd st.", "Apt. 2112", "Middletown", "IN", "45978", "US", "Neil P. Lifeson",
           "598 W. 3rd st.", "Apt. 2112", "Middletown", "IN", "45978", "US" );

INSERT INTO Customer
   VALUES (NULL, "Alex", "Z", "Peart", "602-555-5309", "", "alexziv@rush.net",
           "24 S. May Parkway", "", "Middletown", "AZ", "85054", "US", "Alex Z. Peart",
           "24 S. May Parkway", "", "Middletown", "AZ", "85054", "US" );

INSERT INTO Customer
   VALUES (NULL, "Ron", "J", "Beyer", "814-555-1938", "", "ronb@zkyu.com",
           "987 W. Alameda", "", "Jacksonville", "FL", "34040", "US", "Ron J. Beyer",
           "987 W. Alameda", "", "Jacksonville", "FL", "34040", "US" );

INSERT INTO Customer
   VALUES (NULL, "Doug", "B", "Stevenson", "253-555-9634", "", "dougst3@halcyon.com",
           "12106 SE 9th St.", "#45", "Everett", "WA", "98158", "US", "Doug B. Stevenson",
           "12106 SE 9th St.", "#45", "Everett", "WA", "98158", "US" );

INSERT INTO Customer
   VALUES (NULL, "Yancy", "M", "Colling", "415-555-3376", "", "yc@netqw.org",
           "100 Stirling Way", "", "Mountain View", "CA", "94043", "US", "Yancy M. Colling",
           "100 Stirling Way", "", "Mountain View", "CA", "94043", "US" );

INSERT INTO Customer
   VALUES (NULL, "Tricia", "P", "Young", "415-555-7843", "", "Triciap@yetting.net",
           "2550 Northside Rd.", "", "Redwood City", "CA", "94061", "US", "Tricia P. Young",
           "2550 Northside Rd.", "", "Redwood City", "CA", "94061", "US" );

INSERT INTO Customer
   VALUES (NULL, "Catherine", "B", "Snow", "802-555-1884", "", "cbs@vmtech.edu",
           "43 N. Berl St.", "", "Monpilier", "VT", "05408", "US", "Catherine B. Snow",
           "43 N. Berl St.", "", "Monpilier", "VT", "05408", "US" );

INSERT INTO Customer
   VALUES (NULL, "Shaunna", "J", "Nilo", "404-555-4398", "", "sjagn@paristx.com",
           "5700 W. Paradise Rd.", "", "Paris", "TX", "34998", "US", "Shaunna J. Nilo",
           "5700 W. Paradise Rd.", "", "Paris", "TX", "34998", "US" );

INSERT INTO Customer
   VALUES (NULL, "Gregg", "S", "Barton", "750-555-1060", "", "greggb@appmethods.com",
           "387 S. Beach Harbor Rd.", "", "Virginia Beach", "VA", "18164", "US", "Gregg S. Barton",
           "387 S. Beach Harbor Rd.", "", "Virginia Beach", "VA", "18164", "US" );

INSERT INTO Customer
   VALUES (NULL, "Robin", "W", "Kott", "602-555-9247", "", "robink@primek1.com",
           "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US", "Robin W. Kott",
           "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US" );

/*******************************************************************************/
/* ORDERS TABLE */
/*******************************************************************************/
INSERT INTO Orders
   VALUES (NULL, 1, "05/15/97", "Fulfilled", "05/21/97", "TRK123", "", "VISA", "1234123412341234",
           "", "UPS", 993.96, "Mary J. Jenkins", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA" );

INSERT INTO Orders
   VALUES (NULL, 1, "06/25/97", "Fulfilled", "06/27/97", "TRK345", "", "VISA", "1234123412341234",
           "", "FedEx", 168.43, "Joseph Wong", 
           "4321 45th Ave NW", "", "Seattle", "WA", "98195", "USA", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA" );

INSERT INTO Orders
   VALUES (NULL, 1, "07/01/97", "Open", NULL, "", "", "VISA", "1234123412341234",
           "", "FedEx", 0, "Mary J. Jenkins", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA", 
           "1234 15th Ave NE #123", "", "Seattle", "WA", "98105", "USA" );

INSERT INTO Orders
   VALUES (NULL, 2, "05/01/97", "BackOrdered", NULL, "TRK567", "", "AMEX", "1111222233334444",
           "", "US Mail", 0.0, "Jeffery M. Robins", 
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA",
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA" );

INSERT INTO Orders
   VALUES (NULL, 2, "07/03/97", "Fulfilled", "07/05/97", "TRK789", "", "AMEX", "1111222233334444",
           "", "FedEx", 417.23, "Jeffery M. Robins", 
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA",
           "1212 NUUANU Ave Apt 206", "", "Honululu ", "HI", "87687", "USA" );

INSERT INTO Orders
   VALUES (NULL, 3, "07/02/97", "Fulfilled", "07/04/97", "TRK890", "", "MASTERCARD", "3333444411112222",
           "", "UPS", 282.69, "Richard W. Smith", 
           "4500 45th Ave SW #401", "", "Seattle", "WA", "98188", "USA",
           "4500 45th Ave SW #401", "", "Seattle", "WA", "98188", "USA" );

INSERT INTO Orders
   VALUES (NULL, 6, "08/14/97", "Open", NULL, "TRKJJK", "", "VISA", "4222222222222",
           "", "FedEx", 0, "John J. Kuslich",
	   "6300 Southcenter Blvd.", "Suite 200", "Seattle", "WA", "98188", "US",
	   "6300 Southcenter Blvd.", "Suite 200", "Seattle", "WA", "98188", "US" );

INSERT INTO Orders
   VALUES (NULL, 8, "08/10/97", "Fulfilled", "08/13/97", "TRKBRT", "", "MASTERCARD", "5424123456789012",
           "", "US Mail", 154.11, "Bert C. Owbean",
	   "81406 E. Greenpark Dr.", "", "Clearwater", "FL", "04148", "US",
	   "81406 E. Greenpark Dr.", "", "Clearwater", "FL", "04148", "US" );

INSERT INTO Orders
   VALUES (NULL, 7, "07/14/97", "BackOrdered", NULL, "TRK435", "", "DISCOVER", "6414111111111111",
           "", "UPS", 400, "Marcellino F. Tanumihardja",
	   "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US",
	   "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US" );

INSERT INTO Orders
   VALUES (NULL, 7, "08/12/97", "Fulfilled", "08/14/97", "TRKVNS2", "", "VISA", "4222222222222222",
           "", "UPS", 154.88, "Marcellino F. Tanumihardja",
	   "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US",
	   "6300 Southcenter Blvd.", "Suite 212", "Seattle", "WA", "98188", "US" );

INSERT INTO Orders
   VALUES (NULL, 9, "10/10/97", "Fulfilled", "10/17/97", "TRK189", "", "COD", "",
           "", "UPS", 130.00, "Dennis B. Freeson",
	   "123 Main St.", "", "Hilo", "HI", "98619", "US",
	   "123 Main St.", "", "Hilo", "HI", "98619", "US" );

INSERT INTO Orders
   VALUES (NULL, 10, "01/16/97", "Open", NULL, "", "", "VISA", "4222222211111111",
           "", "UPS", 0, "Gary E. Lee",
           "345 Maple Rd.", "", "Middletown", "PA", "67098", "US",
           "345 Maple Rd.", "", "Middletown", "PA", "67098", "US" );

INSERT INTO Orders
   VALUES (NULL, 11, "05/24/97", "Open", NULL, "", "", "VISA", "",
           "", "UPS", 0, "Neil P. Lifeson",
	   "598 W. 3rd st.", "Apt. 2112", "Middletown", "IN", "45978", "US",
	   "598 W. 3rd st.", "Apt. 2112", "Middletown", "IN", "45978", "US" );

INSERT INTO Orders
   VALUES (NULL, 12, "12/23/97", "Fulfilled", "12/24/97", "TRKRUSH2", "", "VISA", "",
           "", "UPS", 744.06, "Alex Z. Peart",
	   "24 S. May Parkway", "", "Middletown", "AZ", "85054", "US",
	   "24 S. May Parkway", "", "Middletown", "AZ", "85054", "US" );

INSERT INTO Orders
   VALUES (NULL, 16, "05/10/97", "Fulfilled", "05/12/97", "TRKRED3", "", "VISA", "4222111333444444",
           "", "FedEx", 0, "Tricia P. Young",
	   "2550 Northside Rd.", "", "Redwood City", "CA", "94061", "US",
	   "2550 Northside Rd.", "", "Redwood City", "CA", "94061", "US" );

INSERT INTO Orders
   VALUES (NULL, 17, "11/08/97", "BackOrdered", NULL, "TRKCAT", "", "COD", "",
           "", "US Mail", 150, "Catherine B. Snow",
	   "43 N. Berl St.", "", "Monpilier", "VT", "05408", "US",
	   "43 N. Berl St.", "", "Monpilier", "VT", "05408", "US" );

INSERT INTO Orders
   VALUES (NULL, 19, "07/28/97", "Fulfilled", "07/31/97", "TRKUN1", "", "AMEX", "3783111222987464",
           "", "FedEx", 125.00, "Gregg S. Barton",
	   "387 S. Beach Harbor Rd.", "", "Virginia Beach", "VA", "18164", "US",
	   "387 S. Beach Harbor Rd.", "", "Virginia Beach", "VA", "18164", "US" );

INSERT INTO Orders
   VALUES (NULL, 20, "04/06/97", "Fulfilled", "04/11/97", "TRKKAR1", "SPV683", "COD", "",
           "", "US Mail", 0, "Robin W. Kott",
           "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US",
	   "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US" );

INSERT INTO Orders
   VALUES (NULL, 20, "08/05/97", "BackOrdered", NULL, "TRKKAR2", "SPV977", "VISA", "4222133444876555",
           "", "FedEx", 340.93, "Robin W. Kott",
	   "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US",
	   "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US" );

INSERT INTO Orders
   VALUES (NULL, 20, "06/12/97", "Fulfilled", "06/15/97", "TRKSO2", "", "VISA", "4222133444876555",
           "", "UPS", 334.65, "Robin W. Kott",
	   "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US",
	   "1036 Main St.", "Apt. A309", "Mesa", "AZ", "85201", "US" );

/*******************************************************************************/
/* ORDERITEM TABLE */
/*******************************************************************************/
INSERT INTO OrderItem
   VALUES (1, 1, 1, 249.99);

INSERT INTO OrderItem
   VALUES (1, 2, 2, 129.99);

INSERT INTO OrderItem
   VALUES (1, 3, 1, 98.99);

INSERT INTO OrderItem
   VALUES (1, 9, 1, 269.99);

INSERT INTO OrderItem
   VALUES (2, 5, 3, 32.99);

INSERT INTO OrderItem
   VALUES (2, 6, 1, 49.99);

INSERT INTO OrderItem
   VALUES (3, 2, 1, 129.99);

INSERT INTO OrderItem
   VALUES (3, 4, 2, 22.99);

INSERT INTO OrderItem
   VALUES (3, 10, 1, 179.99);

INSERT INTO OrderItem
   VALUES (4, 4, 2, 22.99);

INSERT INTO OrderItem
   VALUES (4, 10, 1, 179.99);

INSERT INTO OrderItem
   VALUES (4, 6, 1, 49.99);

INSERT INTO OrderItem
   VALUES (5, 9, 1, 269.99);

INSERT INTO OrderItem
   VALUES (5, 5, 3, 32.99);

INSERT INTO OrderItem
   VALUES (6, 1, 1, 249.99);

INSERT INTO OrderItem
   VALUES (7, 11, 1, 119.99);

INSERT INTO OrderItem
   VALUES (8, 37, 1, 6.29 );

INSERT INTO OrderItem
   VALUES (8, 36, 1, 129.99 );

INSERT INTO OrderItem
   VALUES (9, 19, 1, 521.99 );

INSERT INTO OrderItem
   VALUES (9, 23, 3, 34.99 );

INSERT INTO OrderItem
   VALUES (10, 16, 2, 64.99 );

INSERT INTO OrderItem
   VALUES (10, 39, 1, 6.99 );

INSERT INTO OrderItem
   VALUES (11, 3, 1, 98.99 );

INSERT INTO OrderItem
   VALUES (11, 34, 1, 15.99 );

INSERT INTO OrderItem
   VALUES (12, 18, 1, 125.0 );

INSERT INTO OrderItem
   VALUES (13, 14, 2, 46.99 );

INSERT INTO OrderItem
   VALUES (13, 38, 1, 12.99 );

INSERT INTO OrderItem
   VALUES (14, 20, 1, 615.99 );

INSERT INTO OrderItem
   VALUES (14, 23, 1, 34.99 );

INSERT INTO OrderItem
   VALUES (14, 7, 1, 6.99 );

INSERT INTO OrderItem
   VALUES (15, 16, 5, 64.99 );

INSERT INTO OrderItem
   VALUES (15, 25, 1, 14.99 );

INSERT INTO OrderItem
   VALUES (15, 27, 1, 212.50 );

INSERT INTO OrderItem
   VALUES (16, 15, 1, 28.79 );

INSERT INTO OrderItem
   VALUES (16, 29, 1, 109.99 );

INSERT INTO OrderItem
   VALUES (16, 40, 1, 10.50 );

INSERT INTO OrderItem
   VALUES (17, 29, 2, 109.99 );

INSERT INTO OrderItem
   VALUES (18, 22, 1, 699.90 );

INSERT INTO OrderItem
   VALUES (19, 17, 1, 121.50 );

INSERT INTO OrderItem
   VALUES (19, 10, 1, 179.99 );

INSERT INTO OrderItem
   VALUES (20, 11, 1, 119.99 );

INSERT INTO OrderItem
   VALUES (20, 36, 1, 129.99 );

INSERT INTO OrderItem
   VALUES (20, 8, 4, 11.49 );

/*******************************************************************************/
/* L_Status table */
/*******************************************************************************/
INSERT INTO L_Status
   VALUES ("Open");

INSERT INTO L_Status
   VALUES ("Fulfilled");

INSERT INTO L_Status
   VALUES ("BackOrdered");


/*******************************************************************************/
/* L_PAYMETHOD table */
/*******************************************************************************/
INSERT INTO L_PAYMETHOD
   VALUES ("VISA");

INSERT INTO L_PAYMETHOD
   VALUES ("MASTERCARD");

INSERT INTO L_PAYMETHOD
   VALUES ("DISCOVER");

INSERT INTO L_PAYMETHOD
   VALUES ("AMEX");

INSERT INTO L_PAYMETHOD
   VALUES ("CLIFFCARD");

/*  must match value in Res.java */
INSERT INTO L_PAYMETHOD
   VALUES ("COD");



/*******************************************************************************/
/* L_SHIPMETHOD table */
/*******************************************************************************/
INSERT INTO L_SHIPMETHOD
   VALUES ("UPS");

INSERT INTO L_SHIPMETHOD
   VALUES ("FedEx");

INSERT INTO L_SHIPMETHOD
   VALUES ("US Mail");



/*******************************************************************************/
/* CARDNUMBER table */
/*******************************************************************************/
INSERT INTO CARDNUMBER VALUES(0);



/*******************************************************************************/
/* ACCOUNTSTATUS table */
/*******************************************************************************/
INSERT INTO ACCOUNTSTATUS VALUES('OPEN', 'Account is currently active.');
INSERT INTO ACCOUNTSTATUS VALUES('CLOSED', 'Account is currently inactive.');
INSERT INTO ACCOUNTSTATUS VALUES('COLLECTION', 'Account is in collections.');

EXIT;